routes/web.php
<?php

use App\Http\Controllers\AwardsController;
use App\Http\Controllers\PointsController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\SendAwardsController;
use App\Http\Controllers\UsersController;
use App\Http\Controllers\VounchersController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::middleware('auth')->group(function () {

    Route::get('/', [UsersController::class, 'dashboard'])->name('dashboard');

    // USERS
    Route::middleware('admin')->prefix('usuarios')->group(function () {
        Route::name('users.')->group(function () {
            Route::get('/adicionar', [UsersController::class, 'create'])->name('create');
            Route::post('/adicionar', [UsersController::class, 'store'])->name('store');
            Route::get('/visualizando/{id}', [UsersController::class, 'show'])->name('show');
            Route::get('/desabilitar/{id}', [UsersController::class, 'destroy'])->name('destroy');
            Route::get('/editar/{id}', [UsersController::class, 'edit'])->name('edit');
            Route::put('/editar/{id}', [UsersController::class, 'update'])->name('update');
            Route::get('/minha-conta', [UsersController::class, 'account'])->name('account');
            Route::put('/minha-conta', [UsersController::class, 'accountUp'])->name('accountUp');
            Route::get('/barra-lateral', [UsersController::class, 'aside'])->name('aside');
            Route::get('/aniversariantes', [UsersController::class, 'birthdays'])->name('birthdays');
            Route::get('/aprovar/{id}/{status}', [UsersController::class, 'aprove'])->name('aprove');
            Route::get('/ranking', [UsersController::class, 'ranking'])->name('ranking');
            Route::get('/{id?}', [UsersController::class, 'index'])->name('index');
        });
    });
    
    // USERS
    Route::prefix('pontos')->group(function () {
        Route::name('points.')->group(function () {
            Route::get('/', [PointsController::class, 'index'])->name('index');
            Route::post('/adicionar', [PointsController::class, 'store'])->name('store')->middleware('admin');
            Route::get('/pontuacao', [PointsController::class, 'table'])->name('table');
        });
    });
    
    // USERS
    Route::prefix('premios')->middleware('admin')->group(function () {
        Route::name('awards.')->group(function () {
            Route::get('/', [AwardsController::class, 'index'])->name('index');
            Route::get('/adicionar', [AwardsController::class, 'create'])->name('create');
            Route::post('/adicionar', [AwardsController::class, 'store'])->name('store');
            Route::get('/visualizando/{id}', [AwardsController::class, 'show'])->name('show');
            Route::get('/desabilitar/{id}', [AwardsController::class, 'destroy'])->name('destroy');
            Route::get('/editar/{id}', [AwardsController::class, 'edit'])->name('edit');
            Route::put('/editar/{id}', [AwardsController::class, 'update'])->name('update');
        });
    });
    
    // USERS
    Route::prefix('envio-de-premios')->middleware('admin')->group(function () {
        Route::name('send.awards.')->group(function () {
            Route::get('/', [SendAwardsController::class, 'index'])->name('index');
            Route::get('/adicionar', [SendAwardsController::class, 'create'])->name('create');
            Route::post('/adicionar', [SendAwardsController::class, 'store'])->name('store');
            Route::get('/visualizando/{id}', [SendAwardsController::class, 'show'])->name('show');
            Route::get('/desabilitar/{id}/{status}', [SendAwardsController::class, 'destroy'])->name('destroy');
            Route::get('/editar/{id}', [SendAwardsController::class, 'edit'])->name('edit');
            Route::put('/editar/{id}', [SendAwardsController::class, 'update'])->name('update');
            Route::get('/email', [SendAwardsController::class, 'mail'])->name('email');
        });
    });
    
    Route::get('/solicitar', [AwardsController::class, 'results'])->name('awards.results');
    Route::get('/solicitar/{id}', [SendAwardsController::class, 'request'])->name('send.awards.request');

});

Route::get('/teste-email/{email?}', [SendAwardsController::class, 'mail'])->name('email');


require __DIR__.'/auth.php';

app/Models/SendAward.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class SendAward extends Model
{
    use HasFactory;
    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'user_id',
        'award_id',
        'status',
        'observation',
        'created_by',
        'updated_by',
    ];
    

    /**
    * Get the comments for the blog post.
    */
   public function author(): HasOne
   {
       return $this->hasOne(user::class, 'id', 'created_by');
   }

   /**
   * Get the comments for the blog post.
   */
  public function sendFor(): HasOne
  {
      return $this->hasOne(user::class, 'id', 'user_id');
  }

  /**
  * Get the comments for the blog post.
  */
 public function award(): HasOne
 {
     return $this->hasOne(Award::class, 'id', 'award_id');
 }

   /**
  * Get the comments for the blog post.
  */
  public function approved(): HasOne
  {
    return $this->hasOne(user::class, 'id', 'updated_by');
  }
}

app/Http/Controllers/SendAwardsController.php
<?php

namespace App\Http\Controllers;

use App\Mail\Notifications;
use App\Models\Award;
use App\Models\Point;
use App\Models\SendAward;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Mail;

class SendAwardsController extends Controller
{
    protected $request;
    private $repository;
    
    public function __construct(Request $request, SendAward $content)
    {
        
        $this->request = $request;
        $this->repository = $content;

    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

        // GET ALL DATA
        $contents = SendAward::get();

        // RETURN VIEW WITH DATA
        return view('pages.send-awards.index', [
            'contents' => $contents,
        ]);

    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        // GET ALL DATA
        $awards = Award::where('status', 1)->get();
        $users = User::where('status', 1)->where('role_id', 2)->get();
        return view('pages.send-awards.create')->with([
            'awards' => $awards,
            'users' => $users,
        ]);
    }

    // DEFINE FOLDER ROUTE
    public function folderRoute()
    {
        return "public/envio-de-premios/";
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        // GET FORM DATA
        $data = $request->all();

        // CREATED BY
        $data['created_by'] = Auth::id();

        // GET TOTAL POINTS USER
        $pointsUser = Point::where('user_id', $request->user_id)->sum('points');

        // GET AWARD
        $award = Award::find($request->award_id);

        // IF USER HAVE POINTS REQUIRED
        if($pointsUser < $award->points) {
            // REDIRECT AND MESSAGES
            return redirect()
                ->route('send.awards.index')
                ->with('message', 'O usuário não possui pontos suficientes para este prêmio.');
        }

        Point::create([
            'user_id' => $request->user_id,
            'title' => 'Prêmio resgatado: ' . $award->name,
            'points' => -$award->points,
            'award_id' => $award->id,
            'created_by' => Auth::id(),
        ]);

        // SEND DATA
        $send = $this->repository->create($data);

        // GET USER
        $user = User::find($request->user_id);

        if($send){

            // EMAIL
            $email = $user->email;

            // PARAMETERS FROM EMAIL
            $parameters = [
                'fromName' => 'Dalmóbile',
                'fromEmail' => 'smtp@dreamake.com.br',
                'subject' => 'Você acabou de receber um Prêmio!',
            ];

            // CREATE URL FOR RESET PASSWORD
            $btn = 'ACESSAR MINHA CONTA';
            $url = route('dashboard');

            // MESSAGE
            $message = $request->observation;
            
            // CONTENT OF EMAIL
            $data = [
                'name' => $user->name,
                'email' => $email,
                'url' => $url,
                'btn' => $btn,
                'message' => $message,
            ];
            
            // SEND EMAIL
            Mail::to($email)->send(new Notifications($data, $parameters['subject'], $parameters['fromEmail'], $parameters['fromName']));
        }

        // REDIRECT AND MESSAGES
        return redirect()
            ->route('send.awards.index')
            ->with('message', 'Prêmio criado com sucesso.');
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        // VERIFY IF EXISTS
        if(!$content = SendAward::find($id)){
            return redirect()->back();
        }

        // GENERATES DISPLAY WITH DATA
        return view('pages.send-awards.edit')->with([
            'content' => $content,  
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {

        // GET FORM DATA
        $data = $request->all();     
        
        // CHECK IF THE USER SENT AN IMAGE AND VALIDATE
        storeImage($this->folderRoute(), $request->image, $id);

        // UPDATE BY
        $data['updated_by'] = Auth::id();

        // STORING NEW DATA
        $content = SendAward::find($id);
        $content->update($data);

        // REDIRECT AND MESSAGES
        return redirect()
        ->route('send.awards.index')
        ->with('message', 'Prêmio atualizado com sucesso.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id, $status)
    {
        
        // GET DATA
        $content = SendAward::find($id);

        // STORING NEW DATA
        if($status == 1){
            SendAward::where('id', $id)->update(['status' => $status, 'updated_by' => Auth::id()]);
            $message = 'aprovado';
            
            Point::create([
                'user_id' => $content->user_id,
                'title' => 'Prêmio resgatado: ' . $content->award->name,
                'points' => -$content->award->points,
                'award_id' => $content->award->id,
                'created_by' => Auth::id(),
            ]);

        } else {
            SendAward::where('id', $id)->update(['status' => $status, 'updated_by' => Auth::id()]);
            $message = 'cancelado';
        }

        // REDIRECT AND MESSAGES
        return redirect()
        ->route('send.awards.index')
        ->with('message', 'Prêmio <b>'. $content->name . '</b> '. $message .' com sucesso.');

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function request(Request $request, $id)
    {

        // GET FORM DATA
        $data = $request->all();

        // CREATED BY
        $data['created_by'] = Auth::id();

        // GET TOTAL POINTS USER
        $pointsUser = Point::where('user_id', Auth::id())->sum('points');

        // GET AWARD
        $award = Award::find($id);
        

        if($award->valid < date('Y-m-d')){
            // REDIRECT AND MESSAGES
            return redirect()
                ->route('dashboard')
                ->with('message', 'O Prêmio já não é mais válido.');
        }

        // IF USER HAVE POINTS REQUIRED
        if($pointsUser < $award->points) {
            // REDIRECT AND MESSAGES
            return redirect()
                ->route('dashboard')
                ->with('message', 'Você não possui pontos suficientes.');
        }

        // SEND DATA
        SendAward::create([
            'user_id' => Auth::id(),
            'award_id' => $id,
            'status' => 2,
            'created_by' => Auth::id(),
        ]);

        // REDIRECT AND MESSAGES
        return redirect()
            ->route('dashboard')
            ->with('message', 'Prêmio solicitado com sucesso.');
    }

    

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function mail($email = 'jeandreofur@gmail.com')
    {

        // PARAMETERS FROM EMAIL
        $parameters = [
            'fromName' => 'Dalmóbile',
            'fromEmail' => 'smtp@dreamake.com.br',
            'subject' => 'Você acabou de receber um Prêmio!',
        ];

        // CREATE URL FOR RESET PASSWORD
        $btn = 'ACESSAR MINHA CONTA';
        $url = route('dashboard');

        // MESSAGE
        $message = 'Você está recebendo este e-mail porque fez uma solicitação de redefinição de senha para sua conta no site da Dalmobilesjc.';
        
        // CONTENT OF EMAIL
        $data = [
            'name' => 'Jeandreo',
            'email' => $email,
            'url' => $url,
            'btn' => $btn,
            'message' => $message,
        ];
        
        // SEND EMAIL
        Mail::to($email)->send(new Notifications($data, $parameters['subject'], $parameters['fromEmail'], $parameters['fromName']));
        
    }

}

resources/views/pages/send-awards/create.blade.php
@extends('layouts.app')

@section('page-title', 'Enviar Prêmio')

@section('content')
<!--begin::Content-->
<div id="kt_app_content" class="app-content flex-column-fluid pt-10">
    <!--begin::Content container-->
    <div id="kt_app_content_container" class="app-container container-fluid">
        <!--begin::Container-->
        <div id="kt_content_container" class="container-fluid">
            <!--begin::Row-->
            <div class="row g-5 g-xl-8">
                <div class="col-xl-12 m-0 p-0">
                    <div class="card">
                        <div class="card-body fs-6 p-10 text-gray-700">
                            <form action="{{ route('send.awards.store') }}" method="POST" enctype="multipart/form-data">
                                @csrf
                                <div class="row gx-10 mb-5">
                                    @include('pages._forms.sendAwards')
                                    <div class="d-flex justify-content-end mt-5">
                                        <input type="submit" class="btn btn-primary btn-active-danger mb-3" value="Enviar Prêmio"></input>
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
            <!--end::Row-->
        </div>
        <!--end::Container-->
    </div>
</div>
<!--end::Content-->
@endsection

resources/views/pages/send-awards/edit.blade.php
@extends('layouts.app')

@section('page-title', 'Editar Mensagem Prêmio')

@section('content')
<!--begin::Content-->
<div id="kt_app_content" class="app-content flex-column-fluid pt-10">
    <!--begin::Content container-->
    <div id="kt_app_content_container" class="app-container container-fluid">
        <!--begin::Container-->
        <div id="kt_content_container" class="container-fluid">
            <!--begin::Row-->
            <div class="row g-5 g-xl-8">
                <div class="col-xl-12 m-0 p-0">
                    <div class="card">
                        <div class="card-body fs-6 p-10 text-gray-700">
                            <form action="{{ route('send.awards.update', $content->id) }}" method="POST" enctype="multipart/form-data">
                                @method('PUT')
                                @csrf
                                <div class="row gx-10 mb-5">
                                    @include('pages._forms.sendAwards')
                                    <div class="d-flex justify-content-end mt-5">
                                        <input type="submit" class="btn btn-primary btn-active-danger text-light mb-3" value="Atualizar"></input>
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
            <!--end::Row-->
        </div>
        <!--end::Container-->
    </div>
</div>
<!--end::Content-->
@endsection


@section('custom-footer')

<script>

    $('.short-name').keyup(function(){
        var input = $(this);
        var words = input.val().split(' ');
        if (words.length > 2) {
            input.val(words.slice(0, 2).join(' '));
        }
        $('.input-email').val(input.val().normalize('NFD').replace(/[\u0300-\u036f]/g, "").replace(/\s+/g, ".").toLowerCase() + '@dalmobilesjc.com.br');
    });

    $('#auto-pass').click(function(){
        var chars = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJLMNOPQRSTUVWXYZ!@#$%^&*()+?><:{}[]";
        var passwordLength = 16;
        var password = "";

        for (var i = 0; i < passwordLength; i++) {
            var randomNumber = Math.floor(Math.random() * chars.length);
            password += chars.substring(randomNumber, randomNumber + 1);
        }
        console.log(password);
        $('[name="password"]').val(password);
    });

</script>

@endsection

resources/views/pages/send-awards/index.blade.php
@extends('layouts.app')

@section('page-title', 'Gerenciar Prêmios')

@section('url-toolbar', route('send.awards.create'))

@section('text-toolbar', 'Enviar Prêmio')

@section('content')
<!--begin::Content-->
<div id="kt_app_content" class="app-content flex-column-fluid">
    <!--begin::Content container-->
    <div id="kt_app_content_container" class="app-container container-fluid">
        <!--begin::Container-->
        <div id="kt_content_container" class="container-fluid">
            <!--begin::Row-->
            <div class="row g-5 g-xl-8">
                <div class="col-xl-12 p-0">
                    <div class="card">
                        <div class="card-body fs-6 p-10 text-gray-700">
                            <table id="datatables" class="table table-striped table-row-bordered gy-5 gs-7 border rounded">
                                <thead>
                                    <tr class="fw-bold fs-6 text-gray-800 px-7">
                                        <th class="w-50px">ID</th>
                                        <th>Enviado para</th>
                                        <th>Premio</th>
                                        <th>Enviado por</th>
                                        <th>Status</th>
                                        <th>Ações</th>
                                    </tr>
                                </thead>
                                <tbody class="table-pd">
                                    @foreach ($contents as $content)
                                    <tr>
                                        <td>
                                            <span class="text-gray-700">{{ $content->id }}</span>
                                        </td>
                                        <td>
                                            <div class="d-flex align-items-center">
                                                <div class="d-flex justify-content-start">
                                                    <a href="{{ route('send.awards.edit', $content->id) }}" class="text-gray-700 fw-bold text-hover-primary fs-6">{{ Str::limit($content->sendFor->name, 30) }}</a>
                                                </div>
                                            </div>
                                        </td>
                                        <td class="text-gray-700">
                                            <span class="badge badge-light-info">{{ $content->award->name }}</span>
                                        </td>
                                        <td>
                                            <span class="badge badge-light">{{ Str::limit($content->author->name, 20) }}</span>
                                        </td>
                                        <td class="text-gray-700">
                                            <div class="d-flex align-items-center">
                                                @if($content->status == 1)
                                                <span class="badge badge-light-success">Enviado</span>
                                                @elseif($content->status == 3)
                                                <span class="badge badge-light-danger">Cancelado</span>
                                                @else
                                                <span class="badge badge-light-warning">Solicitado</span>
                                                @endif
                                            </div>
                                        </td>
                                        <td>
                                            <div class="d-flex align-items-center icons-edit">
                                                <a href="{{ route('send.awards.edit', $content->id) }}">
                                                    <i class="fas fa-edit px-1" title="Editar"></i>
                                                </a>
                                                @if($content->status == 2)
                                                <a href="{{ route('send.awards.destroy', ['id' => $content->id, 'status' => 1]) }}">
                                                    <i class="fa-solid fa-circle-check px-1" title="Aprovar"></i>
                                                </a>
                                                <a href="{{ route('send.awards.destroy', ['id' => $content->id, 'status' => 3]) }}">
                                                    <i class="fa-solid fa-circle-xmark px-1" title="Cancelar"></i>
                                                </a>
                                                @endif
                                            </div>
                                        </td>
                                    </tr> 
                                    @endforeach
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
            <!--end::Row-->
        </div>
        <!--end::Container-->
    </div>
    <!--end::Post-->
</div>
<!--end::Content-->
@endsection